/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Index.xs. Do not edit this file, edit Index.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Index.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "INLINE.h"
/* Start of C code */

// This code requires at least a C99 compiler (for uint_* types and // comments)

#define MAJOR_VERSION 0
#define MINOR_VERSION 0
#define SUB_VERSION   8

/* Do not put void in the parameters below, it'll break XS */ 
unsigned int GetCCodeVersion( ) {
	return ( MAJOR_VERSION << 20 ) | ( MINOR_VERSION << 10 ) | SUB_VERSION;
}

/*
   All functions below come in two versions, one using single-precision (float) 
   math and variables and the other using double-precision (double) math and 
   variables.  Functionally, the two versions of each function are identical.
*/

unsigned int fast_log2_double(double n) {
	return ceil( log2(n) );
}

unsigned int fast_log2_float(float n) {
	return ceilf( log2f(n) );
}


#define PI 3.14159265358979
#define DEG2RAD (PI / 180.0) *
#define RAD2DEG (180.0 / PI) *

/*
This code accelerates the set-up code in the Search(...) method.  Functionally it is identical to the Perl version.
Called as ( $grid_level, $grid_size, $max_grid_idx, $lat_0_idx, $lat_1_idx, $lon_0_idx, $lon_1_idx ) = ComputeAreaExtrema( $tile_adjust, $max_size, $max_level, $p_lat, $p_lat_rad, $p_lon, $self->{polar_circumference}, $search_radius );
*/

void ComputeAreaExtrema_float( int tile_adjust, unsigned long max_size, unsigned int max_level, float p_lat, float p_lat_rad, float p_lon, float polar_circumference, float search_radius ) {
	Inline_Stack_Vars;  /* For return values */
	
	uint_fast8_t  grid_level   = 0;
	uint_fast32_t grid_size    = 0;
	uint_fast32_t max_grid_idx = 0;
	
	// Determine grid level to search at
	
	// Size of most detailed grid tile at this point (in meters)
	float ns_indexed_meters = ( polar_circumference / 2.0 ) / max_size; // Dividing by two to get pole-to-pole distance
	
	uint_fast8_t shift = fast_log2_float( search_radius / ns_indexed_meters );
	
	shift += tile_adjust;
	
	//  Make sure the shift we computed lies within the index levels
	if (shift < 0) {
		shift = 0;
	} else if (shift >= max_level) {
		shift = max_level - 1;
	}
	
	//  Shift is relative to the highest-resolution zoom level
	//  Determine grid level to use
	grid_level = max_level - shift;
	
	grid_size = 1 << (grid_level+1);
	max_grid_idx = grid_size - 1;
	
	//  Determine which grid tiles need to be checked
	
	//  Get search point's grid indices
	
	float lat_meter_in_degrees = 360.0 / polar_circumference;
	
	float lat_radius = search_radius * lat_meter_in_degrees;
	float lat_radius_rad = DEG2RAD( lat_radius );
	float lon_radius = RAD2DEG( atan2f( sinf(lat_radius_rad), cosf(lat_radius_rad) * cosf(p_lat_rad) ) );
	
	float lat_0 = p_lat - lat_radius;
	float lat_1 = p_lat + lat_radius;
	
	float lon_0 = p_lon - lon_radius;
	float lon_1 = p_lon + lon_radius;
	
	
	if (lat_0 <= -90) {
		lat_0 = -90;
	}
	
	if (lat_1 >= 90) {
		lat_1 = 90;
	}
	
	if      ( lon_0 < -180.0 ) { lon_0 += 360.0; }
	else if ( lon_0 > 180.0 )  { lon_0 -= 360.0; }
	
	if      ( lon_1 < -180.0 ) { lon_1 += 360.0; }
	else if ( lon_1 > 180.0 )  { lon_1 -= 360.0; }
	
	if      ( lat_0 < -90.0 ) { lat_0 = -90.0; }
	else if ( lat_0 >  90.0 ) { lat_0 =  90.0; }
	
	if      ( lat_1 < -90.0 ) { lat_1 = -90.0; }
	else if ( lat_1 >  90.0 ) { lat_1 =  90.0; }
	
	uint_fast32_t lat_0_idx = (uint_fast32_t)( ( lat_0 + 90.0 )  * max_size / 180.0 );
	if (lat_0_idx >= max_size) lat_0_idx = max_size - 1;
	lat_0_idx >>= shift;
	
	uint_fast32_t lat_1_idx = (uint_fast32_t)( ( lat_1 + 90.0 )  * max_size / 180.0 );
	if (lat_1_idx >= max_size) lat_1_idx = max_size - 1;
	lat_1_idx >>= shift;
	
	uint_fast32_t lon_0_idx = ( (uint_fast32_t)( ( lon_0 + 180.0 ) * max_size / 360.0 ) % max_size ) >> shift;
	
	uint_fast32_t lon_1_idx = ( (uint_fast32_t)( ( lon_1 + 180.0 ) * max_size / 360.0 ) % max_size ) >> shift;
	
	if (lat_0_idx > lat_1_idx) {
		uint_fast32_t tmp = lat_1_idx;
		lat_1_idx = lat_0_idx;
		lat_0_idx = tmp;
	}
	
	/* Populate return values (all unsigned integers) */
	
	Inline_Stack_Reset;
	Inline_Stack_Push(sv_2mortal(newSVuv( grid_level )));
	Inline_Stack_Push(sv_2mortal(newSVuv( grid_size )));
	Inline_Stack_Push(sv_2mortal(newSVuv( max_grid_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lat_0_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lat_1_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lon_0_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lon_1_idx )));
	Inline_Stack_Done;
}


void ComputeAreaExtrema_double( int tile_adjust, unsigned long max_size, unsigned int max_level, double p_lat, double p_lat_rad, double p_lon, double polar_circumference, double search_radius ) {
	Inline_Stack_Vars;  /* For return values */
	
	uint_fast8_t  grid_level   = 0;
	uint_fast32_t grid_size    = 0;
	uint_fast32_t max_grid_idx = 0;
	
	// Determine grid level to search at
	
	// Size of most detailed grid tile at this point (in meters)
	double ns_indexed_meters = ( polar_circumference / 2.0 ) / max_size; // Dividing by two to get pole-to-pole distance
	
	uint_fast8_t shift = fast_log2_double( search_radius / ns_indexed_meters );
	
	shift += tile_adjust;
	
	//  Make sure the shift we computed lies within the index levels
	if (shift < 0) {
		shift = 0;
	} else if (shift >= max_level) {	
		shift = max_level - 1;
	}
	
	//  Shift is relative to the highest-resolution zoom level
	//  Determine grid level to use
	grid_level = max_level - shift;
	
	grid_size = 1 << (grid_level+1);
	max_grid_idx = grid_size - 1;
	
	//  Determine which grid tiles need to be checked
	
	//  Get search point's grid indices
	
	double lat_meter_in_degrees = 360.0 / polar_circumference;
	
	double lat_radius = search_radius * lat_meter_in_degrees;
	double lat_radius_rad = DEG2RAD( lat_radius );
	double lon_radius = RAD2DEG( atan2( sin(lat_radius_rad), cos(lat_radius_rad) * cos(p_lat_rad) ) );
	
	double lat_0 = p_lat - lat_radius;
	double lat_1 = p_lat + lat_radius;
	
	double lon_0 = p_lon - lon_radius;
	double lon_1 = p_lon + lon_radius;
	
	
	if (lat_0 <= -90) {
		lat_0 = -90;
	}
	
	if (lat_1 >= 90) {
		lat_1 = 90;
	}
	
	if      ( lon_0 < -180.0 ) { lon_0 += 360.0; }
	else if ( lon_0 > 180.0 )  { lon_0 -= 360.0; }
	
	if      ( lon_1 < -180.0 ) { lon_1 += 360.0; }
	else if ( lon_1 > 180.0 )  { lon_1 -= 360.0; }
	
	if      ( lat_0 < -90.0 ) { lat_0 = -90.0; }
	else if ( lat_0 >  90.0 ) { lat_0 =  90.0; }
	
	if      ( lat_1 < -90.0 ) { lat_1 = -90.0; }
	else if ( lat_1 >  90.0 ) { lat_1 =  90.0; }
	
	uint_fast32_t lat_0_idx = (uint_fast32_t)( ( lat_0 + 90.0 )  * max_size / 180.0 );
	if (lat_0_idx >= max_size) lat_0_idx = max_size - 1;
	lat_0_idx >>= shift;
	
	uint_fast32_t lat_1_idx = (uint_fast32_t)( ( lat_1 + 90.0 )  * max_size / 180.0 );
	if (lat_1_idx >= max_size) lat_1_idx = max_size - 1;
	lat_1_idx >>= shift;
	
	uint_fast32_t lon_0_idx = ( (uint_fast32_t)( ( lon_0 + 180.0 ) * max_size / 360.0 ) % max_size ) >> shift;
	
	uint_fast32_t lon_1_idx = ( (uint_fast32_t)( ( lon_1 + 180.0 ) * max_size / 360.0 ) % max_size ) >> shift;
	
	if (lat_0_idx > lat_1_idx) {
		uint_fast32_t tmp = lat_1_idx;
		lat_1_idx = lat_0_idx;
		lat_0_idx = tmp;
	}
	
	/* Populate return values (all unsigned integers) */
	
	Inline_Stack_Reset;
	Inline_Stack_Push(sv_2mortal(newSVuv( grid_level )));
	Inline_Stack_Push(sv_2mortal(newSVuv( grid_size )));
	Inline_Stack_Push(sv_2mortal(newSVuv( max_grid_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lat_0_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lat_1_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lon_0_idx )));
	Inline_Stack_Push(sv_2mortal(newSVuv( lon_1_idx )));
	Inline_Stack_Done;
}




/*
   Compute distance between two points on a sphere
   
   diameter is in meters
   lat_0, lon_0, lat_1, and lon_1 are in radians
   Distance returned is in meters
   
   To compute a distance first call SetUpDistance(...) with the first point 
   then call HaversineDistance(...) to get the distance to a second point.
   
   The C version can use either floats or doubles whereas Perl uses doubles.  
   When using floats instead of doubles the loss of precision is typically less 
   than a meter (about 2 meters in the worst case).   On modern hardware there 
   should be little noticable difference between using floats and doubles.  On 
   older hardware or in embedded systems floats may give better performance.
*/


/* Functions using floats */

float f_diameter, f_lat_1, f_lon_1;
float f_cos_lat_1;

void SetUpDistance_float(float new_diameter, float new_lat_1, float new_lon_1) {
	f_diameter = new_diameter;
	f_lat_1 = new_lat_1;
	f_lon_1 = new_lon_1;
	f_cos_lat_1 = cosf( new_lat_1 );
}

float HaversineDistance_float(float lat_0, float lon_0) {
	float sin_lat_diff_over_2 = sinf( ( lat_0 - f_lat_1 ) / 2.0 );
	float sin_lon_diff_over_2 = sinf( ( lon_0 - f_lon_1 ) / 2.0 );
	
	float n = ( sin_lat_diff_over_2 * sin_lat_diff_over_2 ) 
	          + (
	              ( sin_lon_diff_over_2 * sin_lon_diff_over_2 )
	              * f_cos_lat_1
	              * cosf( lat_0 )
	            );
	
	/* The haversine formula may get messy around antipodal points so clip to the largest sane value. */
	if ( n < 0.0 ) { n = 0.0; }
	
	return f_diameter  * asinf( sqrtf(n) );
}



/* Functions using doubles */

double d_diameter, d_lat_1, d_lon_1;
double d_cos_lat_1;

void SetUpDistance_double(double new_diameter, double new_lat_1, double new_lon_1) {
	d_diameter = new_diameter;
	d_lat_1 = new_lat_1;
	d_lon_1 = new_lon_1;
	d_cos_lat_1 = cos( new_lat_1 );
}

double HaversineDistance_double(double lat_0, double lon_0) {
	double sin_lat_diff_over_2 = sin( ( lat_0 - d_lat_1 ) / 2.0 );
	double sin_lon_diff_over_2 = sin( ( lon_0 - d_lon_1 ) / 2.0 );
	
	double n = ( sin_lat_diff_over_2 * sin_lat_diff_over_2 ) 
	          + (
	              ( sin_lon_diff_over_2 * sin_lon_diff_over_2 )
	              * d_cos_lat_1
	              * cos( lat_0 )
	            );
	
	/* The haversine formula may get messy around antipodal points so clip to the largest sane value. */
	if ( n < 0.0 ) { n = 0.0; }
	
	return d_diameter  * asin( sqrt(n) );
}

/* End of C code */

#line 332 "Index.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 476 "Index.c"

XS_EUPXS(XS_Geo__Index_GetCCodeVersion); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_GetCCodeVersion)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = GetCCodeVersion();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__Index_fast_log2_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_fast_log2_double)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	double	n = (double)SvNV(ST(0))
;
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = fast_log2_double(n);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__Index_fast_log2_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_fast_log2_float)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    {
	float	n = (float)SvNV(ST(0))
;
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = fast_log2_float(n);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__Index_ComputeAreaExtrema_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_ComputeAreaExtrema_float)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "tile_adjust, max_size, max_level, p_lat, p_lat_rad, p_lon, polar_circumference, search_radius");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	tile_adjust = (int)SvIV(ST(0))
;
	unsigned long	max_size = (unsigned long)SvUV(ST(1))
;
	unsigned int	max_level = (unsigned int)SvUV(ST(2))
;
	float	p_lat = (float)SvNV(ST(3))
;
	float	p_lat_rad = (float)SvNV(ST(4))
;
	float	p_lon = (float)SvNV(ST(5))
;
	float	polar_circumference = (float)SvNV(ST(6))
;
	float	search_radius = (float)SvNV(ST(7))
;
#line 349 "Index.xs"
        I32* temp;
#line 560 "Index.c"
#line 351 "Index.xs"
        temp = PL_markstack_ptr++;
        ComputeAreaExtrema_float(tile_adjust, max_size, max_level, p_lat, p_lat_rad, p_lon, polar_circumference, search_radius);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 571 "Index.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Geo__Index_ComputeAreaExtrema_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_ComputeAreaExtrema_double)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "tile_adjust, max_size, max_level, p_lat, p_lat_rad, p_lon, polar_circumference, search_radius");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	tile_adjust = (int)SvIV(ST(0))
;
	unsigned long	max_size = (unsigned long)SvUV(ST(1))
;
	unsigned int	max_level = (unsigned int)SvUV(ST(2))
;
	double	p_lat = (double)SvNV(ST(3))
;
	double	p_lat_rad = (double)SvNV(ST(4))
;
	double	p_lon = (double)SvNV(ST(5))
;
	double	polar_circumference = (double)SvNV(ST(6))
;
	double	search_radius = (double)SvNV(ST(7))
;
#line 372 "Index.xs"
        I32* temp;
#line 605 "Index.c"
#line 374 "Index.xs"
        temp = PL_markstack_ptr++;
        ComputeAreaExtrema_double(tile_adjust, max_size, max_level, p_lat, p_lat_rad, p_lon, polar_circumference, search_radius);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 616 "Index.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Geo__Index_SetUpDistance_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_SetUpDistance_float)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "new_diameter, new_lat_1, new_lon_1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float	new_diameter = (float)SvNV(ST(0))
;
	float	new_lat_1 = (float)SvNV(ST(1))
;
	float	new_lon_1 = (float)SvNV(ST(2))
;
#line 390 "Index.xs"
        I32* temp;
#line 640 "Index.c"
#line 392 "Index.xs"
        temp = PL_markstack_ptr++;
        SetUpDistance_float(new_diameter, new_lat_1, new_lon_1);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 651 "Index.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Geo__Index_HaversineDistance_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_HaversineDistance_float)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "lat_0, lon_0");
    {
	float	lat_0 = (float)SvNV(ST(0))
;
	float	lon_0 = (float)SvNV(ST(1))
;
	float	RETVAL;
	dXSTARG;

	RETVAL = HaversineDistance_float(lat_0, lon_0);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Geo__Index_SetUpDistance_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_SetUpDistance_double)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "new_diameter, new_lat_1, new_lon_1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	double	new_diameter = (double)SvNV(ST(0))
;
	double	new_lat_1 = (double)SvNV(ST(1))
;
	double	new_lon_1 = (double)SvNV(ST(2))
;
#line 413 "Index.xs"
        I32* temp;
#line 696 "Index.c"
#line 415 "Index.xs"
        temp = PL_markstack_ptr++;
        SetUpDistance_double(new_diameter, new_lat_1, new_lon_1);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 707 "Index.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Geo__Index_HaversineDistance_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Index_HaversineDistance_double)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "lat_0, lon_0");
    {
	double	lat_0 = (double)SvNV(ST(0))
;
	double	lon_0 = (double)SvNV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = HaversineDistance_double(lat_0, lon_0);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Geo__Index); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Geo__Index)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Geo::Index::GetCCodeVersion", XS_Geo__Index_GetCCodeVersion);
        newXS_deffile("Geo::Index::fast_log2_double", XS_Geo__Index_fast_log2_double);
        newXS_deffile("Geo::Index::fast_log2_float", XS_Geo__Index_fast_log2_float);
        newXS_deffile("Geo::Index::ComputeAreaExtrema_float", XS_Geo__Index_ComputeAreaExtrema_float);
        newXS_deffile("Geo::Index::ComputeAreaExtrema_double", XS_Geo__Index_ComputeAreaExtrema_double);
        newXS_deffile("Geo::Index::SetUpDistance_float", XS_Geo__Index_SetUpDistance_float);
        newXS_deffile("Geo::Index::HaversineDistance_float", XS_Geo__Index_HaversineDistance_float);
        newXS_deffile("Geo::Index::SetUpDistance_double", XS_Geo__Index_SetUpDistance_double);
        newXS_deffile("Geo::Index::HaversineDistance_double", XS_Geo__Index_HaversineDistance_double);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

